/*
 * bfs.c:
 *
 * Copyright (c) 2001 James McKenzie <james@fishsoup.dhs.org>,
 * All rights reserved.
 *
 */

static char rcsid[] = "$Id: bfs.c,v 1.1 2001/05/24 13:56:04 root Exp $";

/*
 * $Log: bfs.c,v $
 * Revision 1.1  2001/05/24 13:56:04  root
 * Initial revision
 *
 */

#include <stdio.h>
#include <malloc.h>

static int x, y, w, h, sx, sy, obpl;
static unsigned char *in, *out;
static int ox;

float *next, *nptr;
float *current, *cptr;


#define BLACK (*orow)|=ox
#define WHITE (*orow)&=~ox


void
bfs_dither (int uw, int uh, unsigned char *uin, int usx, int usy,
            unsigned char *uout, int uobpl)
{
  int x, y, s;
  int dir = 0;
  unsigned char *irow;
  unsigned char *orow;

  in = uin;
  w = uw;
  h = uh;
  sx = usx;
  sy = usy;
  out = uout;
  obpl = uobpl;

  s = (w + 2) * sizeof (float);



  next = malloc (s);
  current = malloc (s);

  bzero (current, s);

  for (y = 0; y < h; ++y)
    {
      bcopy (next, current, s);
      bzero (next, s);
      cptr = current + 1;

      x = w;
      irow = in;

      while (x--)
        {
          *(cptr++) += (float) *irow;
          irow += sx;
        }

// Insert buostrophendonic code here

      if (dir)
        {                       // Left ro Right

          x = w;
          cptr = current + 1;
          nptr = next + 1;
          orow = out;

          while (x--)
            {
              float err;

              err = *(cptr++);
              if (err > 127)
                {
                  WHITE;
                  err -= 255.0;
                }
              else
                {
                  BLACK;
                }

              err *= 0.0625;

              (*cptr) += (err * 7.);
              (*(nptr - 1)) += (err * 3.);
              (*nptr) += (err * 5.);
              (*(nptr + 1)) += (err * 1.);

              nptr++;

              ox >>= 1;
              if (!ox)
                {
                  orow++;
                  ox = 128;
                }
            }

        }
      else
        {

          x = w;
          cptr = current + w;
          nptr = next + w;
          orow = out + (w >> 3);
          ox = 128 >> (w % 8);

          while (x--)
            {
              float err;

              err = *(cptr--);
              if (err > 127)
                {
                  WHITE;
                  err -= 255.0;
                }
              else
                {
                  BLACK;
                }

              err *= 0.0625;

              (*cptr) += (err * 7.);
              (*(nptr + 1)) += (err * 3.);
              (*nptr) += (err * 5.);
              (*(nptr - 1)) += (err * 1.);

              nptr--;

              ox <<= 1;
              if (ox == 256)
                {
                  orow--;
                  ox = 1;
                }

            }


        }
      out += obpl;
      in += sy;
	dir^=1;

    }

  free (current);
  free (next);


}
