/*
 * pcmtopcl.c:
 *
 * Copyright (c) 2001 James McKenzie <james@fishsoup.dhs.org>,
 * All rights reserved.
 *
 */

static char rcsid[] =
  "$Id: pcmtopcl.c,v 1.5 2001/05/25 01:30:45 root Exp root $";

/*
 * $Log: pcmtopcl.c,v $
 * Revision 1.5  2001/05/25 01:30:45  root
 * #
 *
 * Revision 1.4  2001/05/25 01:24:37  root
 * #
 *
 * Revision 1.3  2001/05/25 01:22:37  root
 * #
 *
 * Revision 1.2  2001/05/24 13:56:19  root
 * *** empty log message ***
 *
 * Revision 1.1  2001/05/24 13:56:04  root
 * Initial revision
 *
 */

#include <stdio.h>
#include <malloc.h>
#include <strings.h>

#include "printer.h"

get_image_size (infd, xw, yw)
     FILE *infd;
     int *xw, *yw;
{
  char *buf, c[2];

  buf = (char *) malloc (80);

  buf[0] = '\0';
  if (fread (buf, 1, 1, infd) != 1)
    {
      perror ("read");
      exit (1);
    }
  fread (buf + 1, 1, 1, infd);
  buf[3] = '\0';

  if (strncmp (buf, "P0", 2))
    {
      fprintf (stderr, "Input must be in PCM RAW format\n");
      exit (0);
    }
  c[1] = '\0';

  buf[0] = '#';

  while (buf[0] == '#')
    {
      buf[0] = '\0';
      c[0] = '\0';
      while (c[0] != '\n')
        {
          fread (c, 1, 1, infd);
          strcat (buf, c);
        }
    }

  buf[0] = '#';

  while (buf[0] == '#')
    {

      c[0] = '\0';
      buf[0] = '\0';
      while (c[0] != '\n')
        {
          fread (c, 1, 1, infd);
          strcat (buf, c);
        }
    }
  sscanf (buf, "%d %d\n", xw, yw);

  fprintf (stderr, "Image is %d pixels by %d pixels\n", *xw, *yw);

  free (buf);
}



send_float (prn, f)
     FILE *prn;
     float f;
{
  unsigned char c[4], a;
  float *g = (float *) &c[0];
  *g = f;

#ifdef linux
  a = c[0];
  c[0] = c[3];
  c[3] = a;

  a = c[1];
  c[1] = c[2];
  c[2] = a;
#endif

  fwrite (g, sizeof (float), 1, prn);
}







usage ()
{
  fprintf (stderr, "Usage pcmtopcl [-g] [-x #] [-i]\n");
/*
  fprintf(stderr, "  -d # set printer dithering algorythm:\n");
  fprintf(stderr, "       #=0 for continuous tone,1 for snap to primaries,\n");
  fprintf(stderr, "	 3 for device best, 4 for floyd-stienberg,\n");
  fprintf(stderr, "	 7 for cluster, 11 for ordered, and 13 for noise.\n");
  fprintf(stderr, "  -c proccess in host and send to printer as 1 bit cym\n");
  fprintf(stderr, "  -r proccess in host and send to printer as 1 bit rgb\n");
  fprintf(stderr, "  -f floyd-stienberg dither in host\n");
*/
  fprintf (stderr, "  -x # set resolution for output\n");
  fprintf (stderr, "  -i inteligently position the image on the page\n");
  fprintf (stderr, "\n");
/*
  fprintf(stderr, " options (-d and or -g) are incompatable with (-f, -c or -r)\n");
  fprintf(stderr, " options -c and -r are mutually exclusive\n");
*/
  exit (1);
}




call_back (pm)
     Print_mode pm;
{
  int i;
  int j;
  FILE *prn, *infile;
  int xw, yw, sl, el;
  int dither = 0;


  int dbytes;

//  unsigned char  *buf, *abuf, *bbuf, *cbuf;
  unsigned char *rbuf, *gbuf, *bbuf;



  int res = RES;

  //long           *nerr, *err, *err_swap;
  int xo = 0, yo = 120;
  int infd;
  int iflag = 0;
  long off;




  fprintf (stderr, "HP PCL5c printer driver (c) 2001 James McKenzie\n");
  fprintf (stderr, "ABSOLUTELY NO WARRANTY [HEY THIS MAY EVEN WORK]\n");


  res = pm.res;

  prn = stdout;

  infd = 0;
  infile = fdopen (infd, "r");

  get_image_size (infile, &xw, &yw);

  //FIXME:
  //if (pm.be_smart) be_clever(&infd,&xw,&yw,res,&xo,&yo);


  sl = (xw + 7) >> 3;
  dbytes = (xw + 7) >> 3;

  rbuf = (unsigned char *) malloc (sl);
  gbuf = (unsigned char *) malloc (sl);
  bbuf = (unsigned char *) malloc (sl);

  fprintf (prn, "\033%%-12345X@PJL SET LANGUAGE = PCL\015\012");
  if (pm.page_prot)
    {
      fprintf (prn, "@PJL SET PAGEPROTECT = A4\n");
    }
  else
    {
      fprintf (prn, "@PJL SET PAGEPROTECT = OFF\n");
    }

  fprintf (prn, "%s", pm.pjl_render);

  fprintf (prn, "\033E");
  fprintf (prn, "\033&l0O");
  fprintf (prn, "\033&l0E");
  fprintf (prn, "\033*t%dR", pm.res);
  fprintf (prn, "\033*r%dT", yw);
  fprintf (prn, "\033*r%dS", xw);

  fprintf (stderr, "Resolution set to %d\n", pm.res);
  fprintf (stderr, "Sending 4 bit raster to printer\n");

  if (pm.model == MOD_CYM)
    {
      fprintf (stderr, "CYM\n");
      fprintf (prn, "\033*r-3U");
    }
  if (pm.model == MOD_RGB)
    {
      fprintf (stderr, "RGB\n");
      fprintf (prn, "\033*r3U");
    }


  fprintf (stderr, "Starting printing at (%d,%d)\n", xo, yo);
  fprintf (prn, "\033*p%dx%dY", xo, yo);

  fprintf (stderr, "Printer dither mode is %d\n", pm.pcl_render);
  fprintf (prn, "\033*t%dj", pm.pcl_render);

  fprintf (prn, "\033*r1A");
  fprintf (prn, "\033*b0M");

  off = ftell (infile);

  for (i = 0; i < yw; ++i)
    {
      long where = off + (i * sl);

      fseek (infile, where, SEEK_SET);
      fread (rbuf, 1, sl, infile);
      where += (yw * sl);
      fseek (infile, where, SEEK_SET);
      fread (gbuf, 1, sl, infile);
      where += (yw * sl);
      fseek (infile, where, SEEK_SET);
      fread (bbuf, 1, sl, infile);

      {
        unsigned char *soup;
        int q;

        q = sl;
        soup = rbuf;

        while (q--)
          {
            *soup = ~(*soup);
            soup++;
          }

        q = sl;
        soup = gbuf;

        while (q--)
          {
            *soup = ~(*soup);
            soup++;
          }

        q = sl;
        soup = bbuf;

        while (q--)
          {
            *soup = ~(*soup);
            soup++;
          }

      }



      fprintf (prn, "\033*b%dV", dbytes);
      fwrite (rbuf, dbytes, 1, prn);
      fprintf (prn, "\033*b%dV", dbytes);
      fwrite (gbuf, dbytes, 1, prn);
      fprintf (prn, "\033*b%dW", dbytes);
      fwrite (bbuf, dbytes, 1, prn);

    }
  fprintf (prn, "\033*rC");

  fprintf (prn, "\033E");
  fprintf (prn, "\033%%-12345X");
  fclose (prn);
  fclose (infile);

  exit (0);

}

main (argc, argv)
     int argc;
     char **argv;
{
  extern char *optarg;
  extern int optind;

  int g;

  Print_mode pm;

//pm.where=ON_PRINTER;
  pm.pcl_render = PCL_SNAP;
  pm.pjl_render = "@PJL SET LSCREENING = CONTONE\n";
  pm.page_prot = NO;
  pm.res = 300;
  pm.be_smart = NO;
  pm.model = MOD_RGB;
//pm.where=ON_HOST;

  while ((g = getopt (argc, argv, "x:d:crfin")) != EOF)
    switch (g)
      {
      case 'x':
        pm.res = atoi (optarg);
        break;
      case 'i':
        fprintf (stderr, "Not enough coffee to use intelligent mode\n");
        fprintf (stderr, "please add coffee to printer\n");
        exit (1);
        pm.be_smart = YES;
        break;
      case '?':
        usage ();
      }

  call_back (pm);

  return 0;
}
